Package org.apache.sis.metadata.iso.identification

## Class DefaultOperationMetadata

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultOperationMetadata

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`

      @TitleProperty(name="operationName")
      @UML(identifier="SV_OperationMetadata",
           specification=ISO_19115)
      public class DefaultOperationMetadata
      extends ISOMetadata

  Parameter information. The following properties are mandatory in a well-formed metadata according ISO 19115:
  `SV_OperationMetadata` `├─operationName……………………………………………` A unique identifier for this interface. `├─distributedComputingPlatform……` Distributed computing platforms on which the operation has been implemented. `└─connectPoint………………………………………………` Handle for accessing the service interface. `└─linkage…………………………………………………` Location for on-line access using a URL address or similar addressing scheme.
  Note on International Standard versions
  This class is derived from a new type defined in the ISO 19115 international standard published in 2014, while GeoAPI 3.0 is based on the version published in 2003. Consequently this implementation class does not yet implement a GeoAPI interface, but is expected to do so after the next GeoAPI releases. When the interface will become available, all references to this implementation class in Apache SIS will be replaced be references to the `OperationMetadata` interface.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.5
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultOperationMetadata()` | Constructs an initially empty operation metadata.
    `DefaultOperationMetadata​(DefaultOperationMetadata object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Collection<OnlineResource>` | `getConnectPoints()` | Returns the handle for accessing the service interface.
    `List<DefaultOperationMetadata>` | `getDependsOn()` | Returns the list of operation that must be completed immediately before current operation is invoked.
    `Collection<CodeList<?>>` | `getDistributedComputingPlatforms()` | Returns the distributed computing platforms (DCPs) on which the operation has been implemented.
    `InternationalString` | `getInvocationName()` | Returns the name used to invoke this interface within the context of the DCP.
    `InternationalString` | `getOperationDescription()` | Returns free text description of the intent of the operation and the results of the operation.
    `String` | `getOperationName()` | Returns an unique identifier for this interface.
    `Collection<ParameterDescriptor<?>>` | `getParameters()` | Returns the parameters that are required for this interface.
    `void` | `setConnectPoints​(Collection<? extends OnlineResource> newValue)` | Sets the handle for accessing the service interface.
    `void` | `setDependsOn​(List<? extends DefaultOperationMetadata> newValues)` | Sets the list of operation that must be completed before current operation is invoked.
    `void` | `setDistributedComputingPlatforms​(Collection<? extends CodeList<?>> newValues)` | Sets the distributed computing platforms on which the operation has been implemented.
    `void` | `setInvocationName​(InternationalString newValue)` | Sets the name used to invoke this interface within the context of the DCP.
    `void` | `setOperationDescription​(InternationalString newValue)` | Sets free text description of the intent of the operation and the results of the operation.
    `void` | `setOperationName​(String newValue)` | Sets the unique identifier for this interface.
    `void` | `setParameters​(Collection<? extends ParameterDescriptor<?>> newValues)` | Sets the parameters that are required for this interface.

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultOperationMetadata

          public DefaultOperationMetadata()

      Constructs an initially empty operation metadata.

    - #### DefaultOperationMetadata

          public DefaultOperationMetadata​(DefaultOperationMetadata object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.

  - ### Method Detail

    - #### getOperationName

          @UML(identifier="operationName",
               obligation=MANDATORY,
               specification=ISO_19115)
          public String getOperationName()

      Returns an unique identifier for this interface.
      Returns:
        an unique identifier for this interface.

    - #### setOperationName

          public void setOperationName​(String newValue)

      Sets the unique identifier for this interface.
      Parameters:
        `newValue` - the new unique identifier for this interface.

    - #### getDistributedComputingPlatforms

          @UML(identifier="distributedComputingPlatform",
               obligation=MANDATORY,
               specification=ISO_19115)
          public Collection<CodeList<?>> getDistributedComputingPlatforms()

      Returns the distributed computing platforms (DCPs) on which the operation has been implemented.
      Upcoming API change — specialization
      The element type will be changed to the `DistributedComputingPlatform` code list when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Returns:
        distributed computing platforms on which the operation has been implemented.

    - #### setDistributedComputingPlatforms

          public void setDistributedComputingPlatforms​(Collection<? extends CodeList<?>> newValues)

      Sets the distributed computing platforms on which the operation has been implemented.
      Upcoming API change — specialization
      The element type will be changed to the `DistributedComputingPlatform` code list when GeoAPI will provide it (tentatively in GeoAPI 3.1). In the meantime, users can define their own code list class as below:

      >     final class UnsupportedCodeList extends CodeList<UnsupportedCodeList> {
      >         private static final List<UnsupportedCodeList> VALUES = new ArrayList<UnsupportedCodeList>();

      >         // Need to declare at least one code list element.
      >         public static final UnsupportedCodeList MY_CODE_LIST = new UnsupportedCodeList("MY_CODE_LIST");

      >         private UnsupportedCodeList(String name) {
      >             super(name, VALUES);
      >         }

      >         public static UnsupportedCodeList valueOf(String code) {
      >             return valueOf(UnsupportedCodeList.class, code);
      >         }

      >         @Override
      >         public UnsupportedCodeList[] family() {
      >             synchronized (VALUES) {
      >                 return VALUES.toArray(new UnsupportedCodeList[VALUES.size()]);
      >             }
      >         }
      >     }

      Parameters:
        `newValues` - the new distributed computing platforms on which the operation has been implemented.

    - #### getOperationDescription

          @UML(identifier="operationDescription",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public InternationalString getOperationDescription()

      Returns free text description of the intent of the operation and the results of the operation.
      Returns:
        free text description of the intent of the operation and the results of the operation, or `null` if none.

    - #### setOperationDescription

          public void setOperationDescription​(InternationalString newValue)

      Sets free text description of the intent of the operation and the results of the operation.
      Parameters:
        `newValue` - the new free text description of the intent of the operation and the results of the operation.

    - #### getInvocationName

          @UML(identifier="invocationName",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public InternationalString getInvocationName()

      Returns the name used to invoke this interface within the context of the DCP.
      Returns:
        the name used to invoke this interface within the context of the distributed computing platforms, or `null` if none.

    - #### setInvocationName

          public void setInvocationName​(InternationalString newValue)

      Sets the name used to invoke this interface within the context of the DCP.
      Parameters:
        `newValue` - the new name used to invoke this interface within the context of the DCP.

    - #### getConnectPoints

          @UML(identifier="connectPoint",
               obligation=MANDATORY,
               specification=ISO_19115)
          public Collection<OnlineResource> getConnectPoints()

      Returns the handle for accessing the service interface.
      Returns:
        handle for accessing the service interface.

    - #### setConnectPoints

          public void setConnectPoints​(Collection<? extends OnlineResource> newValue)

      Sets the handle for accessing the service interface.
      Parameters:
        `newValue` - the new handle for accessing the service interface.

    - #### getParameters

          @UML(identifier="parameters",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Collection<ParameterDescriptor<?>> getParameters()

      Returns the parameters that are required for this interface.
      Returns:
        the parameters that are required for this interface, or an empty collection if none.

    - #### setParameters

          public void setParameters​(Collection<? extends ParameterDescriptor<?>> newValues)

      Sets the parameters that are required for this interface.
      Parameters:
        `newValues` - the new set of parameters that are required for this interface.

    - #### getDependsOn

          @UML(identifier="dependsOn",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public List<DefaultOperationMetadata> getDependsOn()

      Returns the list of operation that must be completed immediately before current operation is invoked.
      Upcoming API change — generalization
      The element type will be changed to the `OperationMetadata` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Returns:
        list of operation that must be completed immediately, or an empty list if none.

    - #### setDependsOn

          public void setDependsOn​(List<? extends DefaultOperationMetadata> newValues)

      Sets the list of operation that must be completed before current operation is invoked.
      Upcoming API change — generalization
      The element type will be changed to the `OperationMetadata` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Parameters:
        `newValues` - the new list of operation.